;;;
;;; Test functions for basic Scheme functions.
;;;

;* Copyright (c) 1989-1993 Hewlett-Packard Development Company, L.P.
;*		All Rights Reserved

;* Permission is hereby granted, free of charge, to any person obtaining a
;* copy of this software and associated documentation files (the "Software"),
;* to deal in the Software without restriction, including without limitation
;* the rights to use, copy, modify, merge, publish, distribute, sublicense,
;* and/or sell copies of the Software, and to permit persons to whom the
;* Software is furnished to do so, subject to the following conditions:
;* 
;* The above copyright notice and this permission notice shall be included in
;* all copies or substantial portions of the Software.
;* 
;* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
;* DEALINGS IN THE SOFTWARE.

(module test55 (main test55))

(define (TEST55)
    
    ;;; Write length and levels.
    
    (for-each
	(lambda (v n)
		(set-write-level! v)
		(set-write-length! n)
		(format #t "~s ~s	~s~%" v n
			'(if (member x y) (+ (car x) 3)
			     '(foo . #(a b c d "Baz")))))
	'(0 1 1 1 1 2 2 2 3 3 3 #f)
	'(1 1 2 3 4 1 2 3 2 3 4 #f))
    (newline)
    
    ;;; Circularity detection.
    
    (set-write-circle! #t)
    (let* ((x (list 1 2 3 4 5))
	   (y (make-vector 5 x)))
	  (set-cdr! (last-pair x) x)
	  (vector-set! y 4 y)
	  (write y))
    (newline)
    (newline)
    
    ;;; Pretty-printing
    
    (set-write-pretty! #t)
    (write '(for-each
		(lambda (v n)
			(set-write-level! v)
			(set-write-length! n)
			(format #t "~s ~s	~s~%" v n
				'(if (member x y) (+ (car x) 3)
				     '(foo . #(a b c d "Baz")))))
		'(0 1 1 1 1 2 2 2 3 3 3 #f)
		'(1 1 2 3 4 1 2 3 2 3 4 #f)))
    (newline)
    (newline)
    
    (set-write-pretty! #f)
    (pp '(for-each
	     (lambda (v n)
		     (set-write-level! v)
		     (set-write-length! n)
		     (format #t "~s ~s	~s~%" v n
			     '(if (member x y) (+ (car x) 3)
				  '(foo . #(a b c d "Baz")))))
	     '(0 1 1 1 1 2 2 2 3 3 3 #f)
	     '(1 1 2 3 4 1 2 3 2 3 4 #f)))
    (newline)
    #f)
